Shipping estimates
The Shipping estimates API provides the best rate to ship an order.
Endpoint
POST https://marketplace.walmartapis.com/v3/shipping/labels/shipping-estimatesFunction
Use this API to estimate:
- Standard shipping services
- Add-on services
- Cross-border shipping options
Request Samples
Request Sample 1
curl --request POST \ --url https://marketplace.walmartapis.com/v3/shipping/labels/shipping-estimates \ --header 'accept: application/json' \ --header 'content-type: application/json' \ --data '
{ "packageType": "CUSTOM_PACKAGE", "purchaseOrderId": "91088062299813853", "boxItems": [ { "lineNumber": "1", "sku": "sku-1NMeZnK1B1MNJdXde5771022", "quantity": 1 } ], "boxDimensions": { "boxWeightUnit": "LB", "boxWeight": 0.8, "boxLength": 6, "boxWidth": 6, "boxHeight": 6, "boxDimensionUnit": "IN" }, "shipByDate": "2023-06-05T08:00:00.611Z", "deliverByDate": "2023-06-07T23:00:00.611Z", "carriers": [ "FEDEX" ], "fromAddress": { "postalCode": "91776", "countryCode": "US", "addressLines": [ "311 E VALLEY BLVD STE 112 PMB 271as" ], "city": "SAN GABRIEL1as", "state": "CA" }, "toAddress": { "postalCode": "94085", "countryCode": "US", "addressLines": [ "748 N Mathilda Ave", "Room # 224" ], "city": "SUNNYVALE", "state": "CA" }, "includeServicesNotMeetingDeliveryPromise": true
}
'Request Sample 2
curl --request POST \ --url https://marketplace.walmartapis.com/v3/shipping/labels/shipping-estimates \ --header 'accept: application/json' \ --header 'content-type: application/json' \ --data '
{ "packageType": "CUSTOM_PACKAGE", "purchaseOrderId": "91088062299813853", "boxItems": [ { "lineNumber": "1", "sku": "sku-1NMeZnK1B1MNJdXde5771022", "quantity": 1 } ], "boxDimensions": { "boxWeightUnit": "LB", "boxWeight": 0.8, "boxLength": 6, "boxWidth": 6, "boxHeight": 6, "boxDimensionUnit": "IN" }, "shipByDate": "2023-06-05T08:00:00.611Z", "deliverByDate": "2023-06-07T23:00:00.611Z", "carriers": [ "FEDEX" ], "fromAddress": { "postalCode": "91776", "countryCode": "US", "addressLines": [ "311 E VALLEY BLVD STE 112 PMB 271as" ], "city": "SAN GABRIEL1as", "state": "CA" }, "toAddress": { "postalCode": "94085", "countryCode": "US", "addressLines": [ "748 N Mathilda Ave", "Room # 224" ], "city": "SUNNYVALE", "state": "CA" }, "addOns": true, "includeServicesNotMeetingDeliveryPromise": true
}
'Request Sample 3
curl --request POST \ --url https://marketplace.walmartapis.com/v3/shipping/labels/shipping-estimates \ --header 'accept: application/json' \ --header 'content-type: application/json' \ --data '
{ "packageType": "CUSTOM_PACKAGE", "purchaseOrderId": "91088062299813853", "boxItems": [ { "lineNumber": "1", "sku": "sku-1NMeZnK1B1MNJdXde5771022", "quantity": 1 } ], "boxDimensions": { "boxWeightUnit": "LB", "boxWeight": 0.8, "boxLength": 6, "boxWidth": 6, "boxHeight": 6, "boxDimensionUnit": "IN" }, "shipByDate": "2023-06-05T08:00:00.611Z", "deliverByDate": "2023-06-07T23:00:00.611Z", "carriers": [ "YANWEN" ], "fromAddress": { "postalCode": "510599", "countryCode": "CN", "addressLines": [ "GuSu District PingLong Road 251 Hao" ], "city": "guangZhouShi", "state": "GD" }, "toAddress": { "postalCode": "94085", "countryCode": "US", "addressLines": [ "748 N Mathilda Ave", "Room # 224" ], "city": "SUNNYVALE", "state": "CA" }, "hasBattery": false, "includeServicesNotMeetingDeliveryPromise": true
}
' Modify Your Code
Before submitting a request, replace the sample values with real shipment data for:
purchaseOrderId: The purchase order ID of the shipment.boxItems: The number of items in the box of an order.real line number: The order line number on the POsku: Stock keeping unit identifying items in the order catalog and fulfillment flow.quantity: The number of items.boxDimensions: The weight and size of the package.shipByDate: The date the order will be shipped.deliverByDate: The date the order will be delivered.carriers: The name of your carrier or carriers.fromAddress:The address the order will be shipped from.toAddress: The address the order will be shipped to.addOns: Additional services such asSHIPMENT_PROTECTIONorSIGNATURE.hasBattery: An order that requires battery-specific shipping handling.includeServicesNotMeetingDeliveryPromise: The Shipping estimates API shows shipping services despite the requested delivery date not being met.
Response Samples
Response 200 Sample 1
{ "data": { "estimates": [ { "name": "PRIORITY_MAIL", "displayName": "USPS Priority Mail", "deliveryDate": "2023-10-02T23:59:00.000Z", "estimatedRate": { "amount": 7.2, "currency": "USD" }, "serviceTypeGroupName": "USPS_DEFAULT", "serviceTypeGroupDisplayName": "Default", "isDeliveryPromiseFulfilled": false, "carrierName": "USPS", "carrierDisplayName": "USPS" }, { "name": "FEDEX_GROUND", "displayName": "FedEx US Ground", "deliveryDate": "2023-09-29T23:59:00.000Z", "estimatedRate": { "amount": 11.87, "currency": "USD" }, "serviceTypeGroupName": "FEDEX_GROUND", "serviceTypeGroupDisplayName": "FedEx Ground", "isDeliveryPromiseFulfilled": false, "carrierName": "FedEx", "carrierDisplayName": "FedEx" } ], "alertMessage": "We are unable to find a shipping service that would meet this delivery date. You may choose one of the other delivery options below but note that you may be responsible for any late deliveries." }
}Response 200 Sample 2
{ "data": { "estimates": [ { "name": "PRIORITY_MAIL", "displayName": "USPS Priority Mail", "deliveryDate": "2023-10-02T23:59:00.000Z", "estimatedRate": { "amount": 7.2, "currency": "USD" }, "serviceTypeGroupName": "USPS_DEFAULT", "serviceTypeGroupDisplayName": "Default", "isDeliveryPromiseFulfilled": false, "carrierName": "USPS", "carrierDisplayName": "USPS", "addOns": [ { "name": "INSURANCE", "charge": { "amount": 0.33, "currency": "USD" }, "declaredValue": { "amount": 40, "currency": "USD" } } ] }, { "name": "FEDEX_GROUND", "displayName": "FedEx US Ground", "deliveryDate": "2023-09-29T23:59:00.000Z", "estimatedRate": { "amount": 11.87, "currency": "USD" }, "serviceTypeGroupName": "FEDEX_GROUND", "serviceTypeGroupDisplayName": "FedEx Ground", "isDeliveryPromiseFulfilled": false, "carrierName": "FedEx", "carrierDisplayName": "FedEx", "addOns": [ { "name": "INSURANCE", "charge": { "amount": 0.33, "currency": "USD" }, "declaredValue": { "amount": 40, "currency": "USD" } }, { "name": "SIGNATURE", "charge": { "amount": 6.35, "currency": "USD" } } ] } ], "alertMessage": "We are unable to find a shipping service that would meet this delivery date. You may choose one of the other delivery options below but note that you may be responsible for any late deliveries." }
}Result
A successful response returns an array of shipping estimates. Each estimate can include the service name, display name, estimated delivery date, estimated rate, service grouping, carrier details, and whether the service fulfills the delivery promise.
Next Steps
The Create label API lets you buy labels from Walmart to ship orders.
The Label details by purchase order ID API procures shipping label information on multiple orders such as label generation, carrier service type, shipment tracking, shipment protection, and signature protection.
The Supported carriers API provides a list of Walmart's approved carriers to ship orders.
The Download label API retrieves a carrier label by the carrier and tracking number.
The Discard label API removes shipping labels.
The Supported carrier package types API provides package types the carrier offers.
The Create scan form for labels API creates a scan form (also called a shipping manifest) to group multiple labels together for a carrier to scan a single document at pickup.
The Download scan form API downloads a scan form document from the manifestId.
The Get ship-on-date API provides recommendations for the default ship-on-date and maximum ship-on-date on seller orders.
Updated 20 days ago

